commit c79e73e7eda6c6c113ad4a6a88d798ef2da917fd
Author: Deev Patel <dkp10000@gmail.com>
Date:   Thu Jun 6 11:53:25 2024 +0100

    libstdc++: Add missing constexpr to __atomic_impl::__clear_padding
    
    This is called from the std::atomic<floating-point-type> constructor,
    which needs to be usable in constant expressions.
    
    libstdc++-v3/ChangeLog:
    
            * include/bits/atomic_base.h (__atomic_impl::__clear_padding):
            Add missing constexpr specifier.
            * testsuite/29_atomics/atomic_float/constinit.cc: New test.
    
    Co-authored-by: Jonathan Wakely <jwakely@redhat.com>
    (cherry picked from commit ae91b5dd14920ff9671db8ff80c0d763d25f977f)

diff --git a/libstdc++-v3/include/bits/atomic_base.h b/libstdc++-v3/include/bits/atomic_base.h
index dd360302f80..3a23c7881cd 100644
--- a/libstdc++-v3/include/bits/atomic_base.h
+++ b/libstdc++-v3/include/bits/atomic_base.h
@@ -968,7 +968,7 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       }
 
     template<typename _Tp>
-      _GLIBCXX_ALWAYS_INLINE _Tp*
+      _GLIBCXX_ALWAYS_INLINE _GLIBCXX14_CONSTEXPR _Tp*
       __clear_padding(_Tp& __val) noexcept
       {
 	auto* __ptr = std::__addressof(__val);
diff --git a/libstdc++-v3/testsuite/29_atomics/atomic_float/constinit.cc b/libstdc++-v3/testsuite/29_atomics/atomic_float/constinit.cc
new file mode 100644
index 00000000000..6b3f4f76b4c
--- /dev/null
+++ b/libstdc++-v3/testsuite/29_atomics/atomic_float/constinit.cc
@@ -0,0 +1,3 @@
+// { dg-do compile { target c++20 } }
+#include <atomic>
+constinit std::atomic<float> a(0.0f);

